#include "SPI.h"
#include "NRFLite.h"
#include <Wire.h>
#include <avr/wdt.h>

const static uint8_t RADIO_ID = 0;       // Our radio's id.  The transmitter will send to this id.
const static uint8_t PIN_RADIO_CE = 7;
const static uint8_t PIN_RADIO_CSN = 10;

struct RadioPacket // Any packet up to 32 bytes can be sent.
{
  float valuev;
};


float batlow = 56.00; // 1st mosfet switch off voltage
float bathigh = 56.50; // 2nd mosfet switch off voltage
int ledPin5 = 5; // mosfet pin 1
int ledPin6 = 6; // mosfet pin 2
float value;
int Rflag = 0; // initial flag set to zero so will only start to drive mosfets once voltage is recieved.

NRFLite _radio;
RadioPacket _radioData;

unsigned long previousMillis = 0;
const long interval = 3000;

unsigned long previousMillis1 = 0;
const long interval1 = 1000;



void writepin () // Actully write data to regulator mosfets
{
  if (value < batlow && Rflag == 1 ) {
    analogWrite (ledPin5, 255 );
    Serial.println ("low high ");

  } else {
    analogWrite (ledPin5, 2);
    Serial.println ("low low ");
  }

  if (value < bathigh && Rflag == 1) {
    analogWrite  (ledPin6, 255 );
    Serial.println ("high high ");

  }
  else {
    Serial.println ("high low ");
    analogWrite  (ledPin6, 2);
  }
}

void setup()
{
  Serial.begin(115200);
  wdt_disable(); // disable Watch dog timer
  Serial.println("START UP");

  if (!_radio.init(RADIO_ID, PIN_RADIO_CE, PIN_RADIO_CSN, NRFLite::BITRATE250KBPS, 125))
  {
    Serial.println("Cannot communicate with radio");
    while (1); // Wait here forever.
  }
  pinMode(ledPin5, OUTPUT);
  pinMode(ledPin6, OUTPUT);
  analogWrite (ledPin5, 5); // set to " low " as default
  analogWrite  (ledPin6, 5);
  wdt_enable(WDTO_8S); // Enable WDT as this is a pretty important device and needs reliability
}

void loop()
{
  unsigned long currentMillis = millis();


  if (currentMillis - previousMillis >= interval) {
    previousMillis = currentMillis;

    writepin();
    Rflag = (0); // reset our recieved flag to 0
  }

  if (currentMillis - previousMillis1 >= interval1) {
    previousMillis1 = currentMillis;

    Serial.println ("CHECK NRF24L01");
    while (_radio.hasData())
    {
      _radio.readData(&_radioData); // Note how '&' must be placed in front of the variable name.

      Serial.println (" recieved ");
      Serial.println(_radioData.valuev);
      value = (_radioData.valuev);
      Rflag = (1); // set our info recieved flag 1 so will drive mosfets
      Serial.println (Rflag);
      wdt_reset(); // reset WDT flag as Ive gone through Loop .... otherwise Ill reset chip
    }
  }


}
